/* Problem URL: https://codeforces.com/contest/2149/problem/G */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    mt19937 seed(chrono::steady_clock::now().time_since_epoch().count());

    int t;
    cin >> t;
    while (t--) {
        int n, q;
        cin >> n >> q;

        vl fds(n);

        map<ll, int> var;
        repv(i, fds) {
            cin >> i;
            var[i] = 0;
        }

        int v = 0;
        vi inv(var.size());
        repv(i, var) {
            i.second = v;
            inv[v] = i.first;
            v++;
        }

        vvi pos(var.size());

        rep(i, n) {
            fds[i] = var[fds[i]];
            pos[fds[i]].push_back(i);
        }

        while (q--) {
            set<int> ans;

            int l, r;
            cin >> l >> r;
            l--, r--;

            uniform_int_distribution<> rng(l, r);

            int lim = (r - l + 1) / 3;

            rep(i, 50) {
                int now = rng(seed);
                int count = upper_bound(all(pos[fds[now]]), r) - lower_bound(all(pos[fds[now]]), l);

                if (count > lim) {
                    ans.insert(inv[fds[now]]);
                }
            }

            if (ans.empty()) {
                cout << "-1\n";
            }

            repv(i, ans) {
                cout << i << ' ';
            }
            cout << '\n';
        }
    }
}
